; #################################################### Documentation #############################################

; #################################################### Includes ##################################################

; #################################################### Declares ##################################################

; #################################################### Macros ####################################################

; #################################################### Includes ##################################################

OpenConsole()

XIncludeFile "Includes/D3HT.pbi"

DisableExplicit

; #################################################### Startup ###################################################

*D3HT_Table.D3HT_Table = D3HT_Create(4, SizeOf(Integer), 65536)

; #################################################### Main ######################################################

Repeat
  
  Time = ElapsedMilliseconds()
  Old_Amount = D3HT_Get_Elements(*D3HT_Table)
  For i = 1 To 1000000
    Test = i;Random(1000000)
    D3HT_Element_Set_Integer(*D3HT_Table, @Test, i)
  Next
  PrintN("Created "+Str(D3HT_Get_Elements(*D3HT_Table)-Old_Amount)+" element(s). It took "+StrF((ElapsedMilliseconds()-Time)/1000, 4)+"s")
  PrintN("  List contains now "+Str(D3HT_Get_Elements(*D3HT_Table))+" element(s). Memory Usage: "+StrF(D3HT_Get_Memoryusage(*D3HT_Table)/1000000, 4)+"MB")
  
  PrintN("")
  
  Time = ElapsedMilliseconds()
  ;D3HT_Clear(*D3HT_Table)
  For i = 0 To 1000000
    Test = i;Random(123000)
    If Not D3HT_Element_Get_Integer(*D3HT_Table, @Test) = i
      ; #### This shouldn't appear
      PrintN("Something is wrong here, the element doesnt have it's correct value!")
    EndIf
  Next
  PrintN("Read and checked "+Str(i-1)+" element(s). It took "+StrF((ElapsedMilliseconds()-Time)/1000, 4)+"s")
  
  PrintN("")
  
  Time = ElapsedMilliseconds()
  Old_Amount = D3HT_Get_Elements(*D3HT_Table)
  For i = 0 To 1000000
    Test = i;Random(123000)
    D3HT_Element_Free(*D3HT_Table, @Test)
  Next
  ; #### You can also use:
  ;D3HT_Clear(*D3HT_Table)
  ; #### Should be much faster than deleting each element...
  PrintN("Deleted "+Str(Old_Amount-D3HT_Get_Elements(*D3HT_Table))+" element(s). It took "+StrF((ElapsedMilliseconds()-Time)/1000, 4)+"s")
  PrintN("  List contains now "+Str(D3HT_Get_Elements(*D3HT_Table))+" element(s). Memory Usage: "+StrF(D3HT_Get_Memoryusage(*D3HT_Table)/1000000, 4)+"MB")
  
  PrintN("---------------------------------")
  
  Delay(5000)
  
ForEver

; #### I know, it gets never called :P
D3HT_Destroy(*D3HT_Table)
; IDE Options = PureBasic 4.51 (Windows - x64)
; CursorPosition = 44
; FirstLine = 16
; EnableXP
; DisableDebugger